# -*- coding: utf-8 -*-
from django.utils.translation import gettext_lazy as _

children = []
models = [
    {
        'model_name': 'paymentform',
        'model_label': _('payment form'),
        'model_label_plural': _('payment forms')
    },
    {
        'model_name': 'paymentinstallment',
        'model_label': _('payment installment'),
        'model_label_plural': _('payment installments')
    },
]

for model in models:
    add_entry = {
        "title": _("add {}").format(model['model_label']),
        "url_name": f"admin:payment_{model['model_name']}_add",
        "perms": [f"payment.add_{model['model_name']}"],
    }
    children.append(add_entry)
    list_entry = {
        "title": _("{} list").format(model['model_label_plural']),
        "url_name": f"admin:payment_{model['model_name']}_changelist",
        "perms": [
            f"payment.view_{model['model_name']}",
            f"payment.change_{model['model_name']}"
        ],
    }
    children.append(list_entry)

menu_items = [{
    'title': _('payment'),
    'url_name': {'viewname': 'admin:app_list', 'kwargs': {'app_label': 'payment'}},
    'perms': ['payment.*'],
    'children': children
}]
