# Generated by Django 2.2.24 on 2021-06-08 04:44

import django.db.models.deletion
from django.conf import settings
from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='PaymentForm',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('date_create', models.DateTimeField(auto_now_add=True, verbose_name='date create')),
                ('date_last_modify', models.DateTimeField(auto_now=True, verbose_name='date last modify')),
                ('status', models.IntegerField(choices=[(0, 'disable'), (1, 'enable')], default=1, null=True, verbose_name='status')),
                ('ordering', models.IntegerField(default=0, verbose_name='ordering')),
                ('code', models.CharField(max_length=50, unique=True, verbose_name='code')),
                ('name', models.CharField(max_length=255, unique=True, verbose_name='name')),
                ('description', models.TextField(blank=True, verbose_name='description')),
                ('fee', models.DecimalField(decimal_places=2, default=0, max_digits=9, verbose_name='fee')),
                ('discount', models.DecimalField(decimal_places=2, default=0, max_digits=9, verbose_name='discount')),
                ('creator', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='payment_paymentform_creator', to=settings.AUTH_USER_MODEL, verbose_name='creator')),
                ('last_modifier', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='payment_paymentform_last_modifier', to=settings.AUTH_USER_MODEL, verbose_name='last modifier')),
            ],
            options={
                'verbose_name': 'payment form',
                'verbose_name_plural': 'payment forms',
                'ordering': ('ordering', 'code'),
                'permissions': (('list_paymentform', 'Can list payment form'), ('detail_paymentform', 'Can detail payment form'), ('disable_paymentform', 'Can disable payment form')),
            },
        ),
        migrations.CreateModel(
            name='PaymentInstallment',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('date_create', models.DateTimeField(auto_now_add=True, verbose_name='date create')),
                ('date_last_modify', models.DateTimeField(auto_now=True, verbose_name='date last modify')),
                ('status', models.IntegerField(choices=[(0, 'disable'), (1, 'enable')], default=1, null=True, verbose_name='status')),
                ('ordering', models.IntegerField(default=0, verbose_name='ordering')),
                ('code', models.CharField(blank=True, max_length=255, unique=True, verbose_name='code')),
                ('name', models.CharField(blank=True, max_length=511, unique=True, verbose_name='name')),
                ('description', models.TextField(blank=True, verbose_name='description')),
                ('amount', models.IntegerField(default=100, verbose_name='amount %')),
                ('days', models.IntegerField(default=0, verbose_name='days')),
                ('end_month', models.BooleanField(verbose_name='end month')),
                ('days_end_month', models.IntegerField(default=0, verbose_name='days after end month')),
                ('discount', models.DecimalField(decimal_places=2, default=0.0, max_digits=4, verbose_name='discount %')),
                ('fee', models.DecimalField(decimal_places=2, default=0.0, max_digits=4, verbose_name='fee %')),
                ('creator', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='payment_paymentinstallment_creator', to=settings.AUTH_USER_MODEL, verbose_name='creator')),
                ('last_modifier', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='payment_paymentinstallment_last_modifier', to=settings.AUTH_USER_MODEL, verbose_name='last modifier')),
                ('payment_form', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='installments', to='payment.PaymentForm', verbose_name='payment form')),
            ],
            options={
                'verbose_name': 'payment installment',
                'verbose_name_plural': 'payment installments',
                'ordering': ('ordering', 'code'),
                'permissions': (('list_paymentinstallment', 'Can list payment installment'), ('detail_paymentinstallment', 'Can detail payment installment'), ('disable_paymentinstallment', 'Can disable payment installment')),
            },
        ),
    ]
